#include <stdlib.h>
#include <math.h>
#include <stdio.h>
#include <conio.h>
#include <iomanip.h>

FILE *f; //  

//    x       
double rascet(double H,double a,double n,double g, double R, double r){
double N_f, N_o, s ;

	if(r==0){
			N_f=N_o=(a*n*R*(R+H))/2;
			
		}
	else{
		N_f=((a*n*R)/(2.0* pow(r,2) )) * ( (H * pow(r,2)) + (2.0/3.0)*pow(R,3) - (2/3.0)*
			(R* (pow(R,2)-pow(r,2))) * ( sqrt(fabs( 1.0- (pow(r,2)/pow(R,2))))));
		N_o=((a*n*pow(R,2)*H)/2.0)  + (a*n*pow(R,2))/(3.0*pow(r,2))  *  
			((sqrt(fabs(1-( pow(r,2)/pow(R,2)))) *(2*pow(r,2)+pow(R,2)))-pow(R,2));
	}

s=(sqrt( (pow(N_f,2)+pow(N_o,2))-N_f*N_o))/g;	

return s;

}
//-------------------------------------------------------------------------------------------
//     MAX    
double met_1(double E,double A,double B,double g,double H,double R,double n,double a){
	double hag=0,r,X_1,X_2,X_R,x,x1,A1=A,B1=B;
	int i,j;
	
	hag=fabs(B-A)/5.0;
	r=A;
	
a1:	
	j=1;
	X_1=rascet(H,a,n,g,R,r);
	x=r;
		for(i=1;i<=5;i++){

			r+=hag;

			X_2=rascet(H,a,n,g,R,r);
			
			if(j){
				X_R=fabs(X_2-X_1);
				j=0;
				x1=fabs(x-r);
			}

			if(X_1<X_2 ){
				X_1=X_2;
				x=r;
			}

		}
		
		if(fabs(x1)>E && fabs(X_R)>E){
			if((x+hag)<=B1)
				B=(x+hag);

			if((x-hag)>=A1)
				A=(x-hag);
			
			hag=(B-A)/5.0;
			x1=x;
			r=A;
			goto a1;
		}


printf("\n METOD_1: r=%e, R=%.1f, Y(r)=%e",x,R,X_1);
fprintf(f,"\n METOD_1: r=%e, R=%.1f, Y(r)=%e",x,R,X_1);

return X_1;

}
//-----------------------------------------------------------------------------------
// " "   MAX  Y(r).	
double met_2(double E,double A,double B,double g,double H,double R,double n,double a){

double p, q, x_p, x_q;

p=A;
//+(1-0.618034)*(B-A);

q=B;
//A+0.618034*(B-A);

x_p=1-rascet(H,a,n,g,R,p);
x_q=1-rascet(H,a,n,g,R,q);

do{
if(x_p>x_q){

	A=p;
	B=B;
	p=q;
	q=A+0.618031*(B-A);
	x_p=x_q;
	x_q=1-rascet(H,a,n,g,R,q);
}
else{ 

	A=A;
	B=q;
	q=p;
	
	p=A+(1-0.618031)*(B-A);
	x_q=x_p;
	x_p=1-rascet(H,a,n,g,R,p);
}

}while(fabs((B-A))>E && fabs(x_p-x_q)>E);

if(rascet(H,a,n,g,R,p)<rascet(H,a,n,g,R,q)){
	x_p=rascet(H,a,n,g,R,q);
	p=q;
}
else
{
	x_p=rascet(H,a,n,g,R,p);
}

printf("\n METOD_2: r=%e, R=%.1f, Y(r)=%e", p,R, x_p);
fprintf(f,"\n METOD_2: r=%e, R=%.1f, Y(r)=%e", p,R, x_p);
return x_p;

}
//----------------------------------------------------------------------------------------------
//    
void main(){
	int i,j,k;


	char key; 
	double interval_R[100], interval_r[100];
	double R;
	const double hag_R=0.2,	kol_hag_r=5;;
	double r , hag_r;

	const double H=1, n=1, a=1e4, g=32.0e7, E=0.1e-5; // 
	double mat_s[100][100];

	f=fopen("rez.txt","w");
	if(f==NULL)
		printf("\n\a ERR FILE!");


	k=0;
    r=0;
	R=0.2;
	for(i=1;i<=5;i++){
		
		interval_R[i-1]=R;
		hag_r=R/kol_hag_r;
		r=0;
		for(j=1;j<=6;j++){
		
			interval_r[k]=r;
			mat_s[k][i-1]=rascet(H,a,n,g,R,r); //      
			//	 Y(r)  R: 0.2  1 ( )
	
			r+=hag_r;
			k++;

		}
			
		R+=hag_R;
	}


do{
		
	printf("\n1: Isledovanie zavisimosti\n2: Poisk MAX\n3: Exit\n");
	fprintf(f,"\n1: Isledovanie zavisimosti\n2: Poisk MAX\n3: Exit\n");
		key=getch(); //  

	if(key=='1'){
		printf("\nH=%.3e, n=%.3e, a=%.3e, g=%.3e, E=%.3e\n",H, n, a, g, E);
		fprintf(f,"\nH=%.3e, n=%.3e, a=%.3e, g=%.3e, E=%.3e\n",H, n, a, g, E);

	
			printf("\n____________________________________________________________________________\n r\\R|    ");
			fprintf(f,"\n____________________________________________________________________________\n r\\R|    ");
			
			for(i=0;i<5;i++){
				printf("%f      ",interval_R[i]);
				fprintf(f,"%f      ",interval_R[i]);
			}
			printf("\n----------------------------------------------------------------------------\n");
			fprintf(f,"\n----------------------------------------------------------------------------\n");

			for(j=0;j<k;j++){
				printf("%.2f| ",interval_r[j]);
				fprintf(f,"%.2f| ",interval_r[j]);
				for(i=0;i<5;i++){ 	
					if(mat_s[j][i]){
						printf("%e ",mat_s[j][i]);
						fprintf(f,"%e ",mat_s[j][i]); //  
					}
					else
					{
						printf("%6c        ",'x'); 
						fprintf(f,"%6c        ",'x'); 
					}
				}
				printf("\n");
				fprintf(f,"\n");
			
			}

	}
	else if(key=='2')
	{
		
		//system("cls");
			char key;
		do{	
			printf("\n1: Metod_1\n2: Metod_2\n3: Analiz\n4: Exit");
			fprintf(f,"\n1: Metod_1\n2: Metod_2\n3: Analiz\n4: Exit");
			key=getch();
	
		if(key=='1'){ 
			fprintf(f,"\nH=%.3e, n=%.3e, a=%.3e, g=%.3e, E=%.3e\n",H, n, a, g, E);
			printf("\nH=%.3e, n=%.3e, a=%.3e, g=%.3e, E=%.3e\n",H, n, a, g, E);

			R=0.2;
			for(i=1;i<=5;i++){
				met_1(E,0,R,g,H,R,n,a);  //  MAX  Y(r) ,  
				R+=hag_R;
			}
		}
		else if(key=='2'){
			fprintf(f,"\nH=%.3e, n=%.3e, a=%.3e, g=%.3e, E=%.3e\n",H, n, a, g, E);
			printf("\nH=%.3e, n=%.3e, a=%.3e, g=%.3e, E=%.3e\n",H, n, a, g, E);

			R=0.2;
			for(i=1;i<=5;i++){
				met_2(E,0,R,g,H,R,n,a);//  MAX Y(r) " "
				R+=hag_R;
			}
		}
		else if(key=='3'){
			fprintf(f,"\nH=%.3e, n=%.3e, a=%.3e, g=%.3e, E=%.3e\n",H, n, a, g, E);
			printf("\nH=%.3e, n=%.3e, a=%.3e, g=%.3e, E=%.3e\n",H, n, a, g, E);

			R=0.2;
			for(i=1;i<=5;i++){
				double x1,x2;
				x1=met_1(E,0,R,g,H,R,n,a);	
				x2=met_2(E,0,R,g,H,R,n,a);   //    
				printf("\n abs(met_1-met_2)=E=%e\n", fabs(x1-x2));
				fprintf(f,"\n abs(met_1-met_2)=e=%f\n", fabs(x1-x2)); 
				R+=hag_R;
			}
		}

		}
		while(key!='4');
		printf("\n");

	}

}
while(key!='3');
//getchar();
}
